checkRequire("Lua_CopyMoneyItem");
Lua_CopyMoneyWindow = class("Lua_CopyMoneyWindow", Lua_Window);
function Lua_CopyMoneyWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyMoneyWindow";
	self.skinName = "CopyMoneyWindow_skin";
end

function Lua_CopyMoneyWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.isInit = false;

	self.descBg.imgTypeNum = 4;
	self.descBg.widget.border = Vector4(0, 10, 0, 10);

	self:addLuaEvent("COPY_MONEY_ITEM_SELECTED", self, self.onCopyMoneyItemClick);
	self:addLuaEvent("PACK_UPDATE", self, self.onPackChange);

	self.dragList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 984, 344));
	self.dragList:setLocation(0, 69, 0);
	self.dragList:setListCell(Lua_CopyMoneyItem, 344, 328, 9999);
	self.dragList:setCellScaleChange(true, 0.6, 1, 320, self, self.onDragListSelected);

	self.rewardItem = Lua_RewardItem.new(self.content);
	self.rewardItem:setLocation(304, -155, 0);
	self.rewardItem:setDepth(5);

	self.leftSp.clickScale = false;
	self.rightSp.clickScale = false;
	self.leftSp:addClickFuntion(self, self.onLeftClick);
	self.rightSp:addClickFuntion(self, self.onRightClick);

	self.subBtn:addClickFuntion(self, self.onEnterClick);
	self.saoBtn:addClickFuntion(self, self.onSaoClick);
	self.addSp:addClickFuntion(self, self.onAddClick);

	self.saoTxt.clickScale = false;
	self.saoImg.clickScale = false;
	self.saoTxt:addClickFuntion(self, self.onSaoItemClick);
	self.saoImg:addClickFuntion(self, self.onSaoItemClick);

	self:addLuaEvent("COPY_DATA_UPDATE", self, self.onCopyDataUpdate);
end

function Lua_CopyMoneyWindow:showWin(param)
	local index_id;
	if type(param) == "table" then
		self.data = param;
		index_id = self.data.id;
	else
		self.data = DataCenter.copyData:getCopyById(tonumber(param));
		index_id = param;
	end

	-- 双倍副本活动开启后 显示UI
	local isOpenDouble = DataCenter.OpenDressCarnivalData:isOpenCopyDouble(tonumber(index_id))
	if DataCenter.OpenDressCarnivalData:isOpenCopyDoubleExp(tonumber(index_id)) == true or isOpenDouble then
		self.doubleExpObj:SetActive(true);
	else
		self.doubleExpObj:SetActive(false);
	end
	Lua_CopyUtil.sendGetCopyInfoMsg(self.data.id);
	self.infoTxt.text = self.data.des;
	self:onCopyDataUpdate();
end

function Lua_CopyMoneyWindow:onCopyDataUpdate()
	local copyVo = self.data;
	self.titleName.text = copyVo.name;
	self.titleSp:setAltas("copy_atlas_1", copyVo.title_sp);
	self.bg:setUrl("/images/copy/"..copyVo.bg_name..".png");

	self.copyList = Array();
	local degree_amount = copyVo.degree_amount;
	local targetIndex = 1;
	for i = 1, degree_amount do
		local v = getConfig({copyVo.another_config, 2000000 + 1000 * copyVo.script_type + i});
		v.index = i;
		v.dif = i;
		v.script_type = copyVo.script_type;
		if i ~= 1 then
			if v.open_star <= copyVo:getDegressStar(i - 2) then
				v.starOk = true;
			else
				v.starOk = false;
			end
		else
			v.starOk = true;
		end

		if Lua_CopyUtil.canEnterCopy(self.data.id, i) == true then
			targetIndex = i;
		end
		self.copyList:add(v);
	end

	if self.curIndex == nil then
		self.curIndex = targetIndex;
	end

	if copyVo.script_type == Lua_CopyData.JUHUN_COPY then
		self:onDragListSelected(1);
	else
		self.dragList:setScaleSelected(self.curIndex);
		self.dragList:setLuaArrayData(self.copyList, false);
		self.dragList:setScaleSelected(nil);
	end

	self.isInit = true;
	self.dragList:moveToIndex(self.curIndex);
	local hasTime = false;
	if copyVo.leftTimes == nil or copyVo.leftTimes <= 0 then
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121109), "0");
	else
		hasTime = true;
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121109), tostring(copyVo.leftTimes));
	end

	-- 2022/8/8 策划要求，不需要显示特效
	-- if (copyVo.leftBuyTimes == nil or copyVo.leftBuyTimes <= 0) or hasTime == true then
	-- 	self:showEffect(false);
	-- else
	-- 	self:showEffect(true);
	-- end
end

function Lua_CopyMoneyWindow:onDragListSelected(val)
	if self.isInit == true then
		self.curIndex = val;
		self.leftSp:setEnable(self.curIndex ~= 1);
		self.rightSp:setEnable(self.curIndex ~= self.copyList:getSize());

		local curData = self.copyList[val];
		local arr = Array();
		for i,v in ipairs(curData.reward) do
			arr:add(v);
		end

		self.rewardItem:setClickWin(true);
		self.rewardItem:setRewardByRewardList(arr);
		-- self.doubleExpObj.transform.localPosition = Vector3(258 + (46 * self.rewardItem.itemList:getSize()), -155, 0);
		LuaUtil.setObjPos(self.doubleExpObj, 258 + (46 * self.rewardItem.itemList:getSize()), -155, 0);

		local cvo = self.data:getSaoDangCost(val);
		if cvo ~= nil and self.data.script_type ~= Lua_CopyData.JUHUN_COPY then
			self.saoTxt:setEnable(true);
			self.saoImg:setEnable(true);
			local tvo = Lua_ToolVo.createToolVo(cvo[1], 1, 0);
			local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cvo[1]);
			self.saoImg:setAltas(tvo.atlas, tvo.referenceId);
			if itemNum >= cvo[2] then
				self.saoTxt.text = "[85A8BE]"..LanUtil.formateStr(LanUtil.getValue(121193), "[00E125]"..itemNum.."[-]", tostring(cvo[2])).."[-]";
			else
				self.saoTxt.text = "[85A8BE]"..LanUtil.formateStr(LanUtil.getValue(121193), "[FF1616]"..itemNum.."[-]", tostring(cvo[2])).."[-]";
			end
		else
			self.saoTxt:setEnable(false);
			self.saoImg:setEnable(false);
		end
	end
end

function Lua_CopyMoneyWindow:showEffect(val)
	if val == true then
		if self.hangEffect == nil then
			self.hangEffect = UICreate.createUIEffect(self.addSp.mainContent, "/effects/scsEffects/gui_guajishijian", "gui_guajishijian", 0, 0);
			self.hangEffect:setLoop(true);
			self.hangEffect:setSacle(1, 1, 1);
			self.hangEffect:SetRenderQueue(self.btnClose, 11, 2, false);
		end
		self.hangEffect:setEnable(true);
	else
		if self.hangEffect ~= nil then
			self.hangEffect:setEnable(false);
		end
	end
end

function Lua_CopyMoneyWindow:onCopyMoneyItemClick(val)
	self.dragList:moveToIndex(val.index);
end

function Lua_CopyMoneyWindow:onPackChange()
	self:onDragListSelected(self.curIndex);
end

function Lua_CopyMoneyWindow:onLeftClick(val)
	self.dragList:moveToIndex(self.curIndex - 1);
end

function Lua_CopyMoneyWindow:onRightClick(val)
	self.dragList:moveToIndex(self.curIndex + 1);
end

function Lua_CopyMoneyWindow:onEnterClick(o)
	if self:checkEnter() == false then
		return;
	end
	local curData = self.copyList[self.curIndex];
	Lua_CopyUtil.enterCopy(self.data.id, curData.dif);
end

function Lua_CopyMoneyWindow:checkEnter()
	local copyVo = self.data;
	if copyVo.leftTimes == nil or copyVo.leftTimes <= 0 then
		local maxVipLv = getConfig({"vip_const", "max_vip_lv", "value"});
		local t = copyVo.leftBuyTimes;
		if DataCenter.roleData.vipType == maxVipLv and (t == nil or t == 0) then
			return true;
		end
		OperateAlert.show(LanUtil.getValue(121158));
		self:onAddClick();
		return false;
	end
	return true;
end

function Lua_CopyMoneyWindow:onAddClick(o)
	local copyVo = self.data;
	local t = copyVo.leftBuyTimes;
	if t == nil then
		t = 0;
	end

	Lua_WindowUtil.openWin("Lua_BuyTimesWindow", WinParam.ACTION_OPEN, {owner = self, configSign = copyVo.vip_index,
		residueTimes = t, costList = copyVo:getBuyTimeCostList(),
		costType = copyVo:getBuyTimeCostType(), useGold = 1, callback = self.onBuyTimes});
end

function Lua_CopyMoneyWindow:onBuyTimes(val)
	Lua_CopyUtil.buyCopyTime(self.data.id, val)
end

function Lua_CopyMoneyWindow:onSaoClick(o)
	if self:checkEnter() == false then
		return;
	end

	local cvo = self.data:getSaoDangCost(self.curIndex);
	if cvo ~= nil and self.data.script_type ~= Lua_CopyData.JUHUN_COPY  then
		local tvo = Lua_ToolVo.createToolVo(cvo[1], 1, 0);
		local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(cvo[1]);
		if itemNum < cvo[2] then
			local neednum = cvo[2] - itemNum;
			local str = LanUtil.formateStr(LanUtil.getValue(121194), self.data.name, tostring(cvo[2]),
				tvo.colorName, tostring(neednum * Lua_CommonUtil.getCommonConfig("script_clean_gold",1)), tvo.colorName);
			Lua_WindowUtil.openWin("Lua_ItemDirectBuyWindow", nil, {owner = self, callBack = self.onItemDirectOk,
			itemId = cvo[1], needNum = cvo[2], info = str});
			return;
		end
	end

	local curData = self.copyList[self.curIndex];
	if self.data.id == Lua_CopyData.JUHUN_COPY then
		local infoData = DataCenter.copyInfoData;
		if infoData.script_type == Lua_CopyData.JUHUN_COPY then
			OperateAlert.show(LanUtil.getValue(121184));
			return;
		end
		Lua_WindowUtil.openWin("Lua_JuHunZhuanPanWindow",WinParam.ACTION_OPEN, {saoDang = 1});
	else
		Lua_CopyUtil.saoDangCopy(self.data.id, curData.dif);
	end
end

function Lua_CopyMoneyWindow:onItemDirectOk()
	local curData = self.copyList[self.curIndex];
	Lua_CopyUtil.saoDangCopy(self.data.id, curData.dif);
end

function Lua_CopyMoneyWindow:onSaoItemClick(o)
	local cvo = self.data:getSaoDangCost(self.curIndex);
	if cvo ~= nil and self.data.script_type ~= Lua_CopyData.JUHUN_COPY  then
		local tvo = Lua_ToolVo.createToolVo(cvo[1], 1, 0);
		Lua_PackUtil.showItemInfo(tvo, false);
	end
end

function Lua_CopyMoneyWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	if self.rewardItem ~= nil then
		self.rewardItem:dispose();
		self.rewardItem = nil;
	end
	if self.hangEffect ~= nil then
		self.hangEffect:dispose();
		self.hangEffect = nil;
	end

	self:superCall("dispose");
end