Lua_CopyMoneyItem = class("Lua_CopyMoneyItem", Lua_ListCell);
function Lua_CopyMoneyItem:ctor(p)
	self:superCall("ctor", p, "CopyMoneyItem_skin");
end

function Lua_CopyMoneyItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local copyVo = DataCenter.copyData:getCopyById(self._data.script_type);
	if self._data.dif == 1 then
		self.difSp:setAltas("copy_atlas_1", "ui_fuben_nandu_jiandan");
	elseif self._data.dif == 2 then
		self.difSp:setAltas("copy_atlas_1", "ui_fuben_nandu_putong");
	elseif self._data.dif == 3 then
		self.difSp:setAltas("copy_atlas_1", "ui_fuben_nandu_kunnan");
	elseif self._data.dif == 4 then
		self.difSp:setAltas("copy_atlas_1", "ui_fuben_nandu_jingying");
	elseif self._data.dif == 5 then
		self.difSp:setAltas("copy_atlas_1", "ui_fuben_nandu_fengkuang");
	elseif self._data.dif == 6 then
		self.difSp:setAltas("copy_atlas_1", "ui_fuben_nandu_diyu");
	else
		self.difSp:setAltas("copy_atlas_1", "ui_fuben_nandu_shishi");
	end

	if self._data.open_level > DataCenter.roleData.level or self._data.starOk == false then
		self.lockSp:setEnable(true);
		self.openTxt:setEnable(true);
		if self._data.open_level > DataCenter.roleData.level then
			self.openTxt.text = LanUtil.formateStr(LanUtil.getValue(121107), tostring(self._data.open_level));
		else
			self.openTxt.text = LanUtil.formateStr(LanUtil.getValue(121117), tostring(self._data.open_star));
		end
		self.bg:setGray(true);
		self.difSp:setGray(true);
		self:setStarGray(0);
	elseif self._data.dif > 1 and copyVo:isDegressPass(self._data.dif - 1) == false then
		self.lockSp:setEnable(true);
		self.openTxt:setEnable(true);
		self.bg:setGray(true);
		self.difSp:setGray(true);
		self:setStarGray(0);
		self.openTxt.text = LanUtil.getValue(121123);
	else
		self.lockSp:setEnable(false);
		self.openTxt:setEnable(false);
		self.difSp:setGray(false);
		self.bg:setGray(false);
		
		local star = copyVo:getDegressStar(self._data.dif);
		if self._data.script_type == Lua_CopyData.JUHUN_COPY then
			self:setStarState(false);
		else
			self:setStarGray(star);
		end
	end
end

function Lua_CopyMoneyItem:setStarGray(val)
	for i = 1, 3 do
		-- self["star"..i]:setGray(i > val);

		if i > val then
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing_s");
		else
			self["star"..i]:setAltas("copy_atlas_2", "ui_fuben_nanduxing");
		end
	end
end

function Lua_CopyMoneyItem:setStarState(val)
	for i = 1, 3 do
		self["star"..i]:setEnable(val);
	end
end

function Lua_CopyMoneyItem:onPlayerSoundClick()
	Lua_MsgUtil.callFunc("COPY_MONEY_ITEM_SELECTED", self._data);
end